---
title: Uint32Array() constructor
slug: Web/JavaScript/Reference/Global_Objects/Uint32Array/Uint32Array
tags:
  - Constructor
  - JavaScript
  - Reference
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>Uint32Array()</code></strong> typed array constructor creates an array of 32-bit unsigned integers in the platform byte order. If control over byte order is needed, use {{jsxref("DataView")}} instead. The contents are initialized to <code>0</code>. Once established, you can reference elements in the array using the object's methods, or using standard array index syntax (that is, using bracket notation).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new Uint32Array(); // new in ES2017
new Uint32Array(<var>length</var>);
new Uint32Array(<var>typedArray</var>);
new Uint32Array(<var>object</var>);
new Uint32Array(<var>buffer</var> [, <var>byteOffset</var> [, <var>length</var>]]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>length</var></code></dt>
 <dd>When called with a <code><var>length</var></code> argument, an internal array buffer is created in memory, of size <code><var>length</var></code><em> multiplied by <code>BYTES_PER_ELEMENT</code></em> bytes, containing zeros.</dd>
 <dt><code><var>typedArray</var></code></dt>
 <dd>When called with a <code>typedArray</code> argument, which can be an object of any of the typed array types (such as <code>Int32Array</code>), the <code><var>typedArray</var></code> gets copied into a new typed array. Each value in <code><var>typedArray</var></code> is converted to the corresponding type of the constructor before being copied into the new array. The length of the new typed array will be same as the length of the <code><var>typedArray</var></code> argument.</dd>
 <dt><code><var>object</var></code></dt>
 <dd>When called with an <code><var>object</var></code> argument, a new typed array is created as if by the <code><var>TypedArray</var>.from()</code> method.</dd>
 <dt><code><var>buffer</var></code>, <code><var>byteOffset</var></code>, <code><var>length</var></code></dt>
 <dd>When called with a <code><var>buffer</var></code>, and optionally a <code><var>byteOffset</var></code> and a <code><var>length</var></code> argument, a new typed array view is created that views the specified {{jsxref("ArrayBuffer")}}. The <code><var>byteOffset</var></code> and <code><var>length</var></code> parameters specify the memory range that will be exposed by the typed array view. If both are omitted, all of <code><var>buffer</var></code> is viewed; if only <code><var>length</var></code> is omitted, the remainder of <code><var>buffer</var></code> is viewed.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Different_ways_to_create_a_Uint32Array">Different ways to create a Uint32Array</h3>

<pre class="brush: js notranslate">// From a length
var uint32 = new Uint32Array(2);
uint32[0] = 42;
console.log(uint32[0]); // 42
console.log(uint32.length); // 2
console.log(uint32.BYTES_PER_ELEMENT); // 4

// From an array
var arr = new Uint32Array([21,31]);
console.log(arr[1]); // 31

// From another TypedArray
var x = new Uint32Array([21, 31]);
var y = new Uint32Array(x);
console.log(y[0]); // 21

// From an ArrayBuffer
var buffer = new ArrayBuffer(16);
var z = new Uint32Array(buffer, 0, 4);

// From an iterable
var iterable = function*(){ yield* [1,2,3]; }();
var uint32 = new Uint32Array(iterable);
// Uint32Array[1, 2, 3]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-typedarray-constructors', 'TypedArray constructors')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Uint32Array.Uint32Array")}}</p>

<h3 id="Compatibility_notes">Compatibility notes</h3>

<p>Starting with ECMAScript 2015, <code>Uint32Array</code> constructors require to be constructed with a {{jsxref("Operators/new", "new")}} operator. Calling a <code>Uint32Array</code> constructor as a function without <code>new</code>, will throw a {{jsxref("TypeError")}} from now on.</p>

<pre class="brush: js example-bad notranslate">var dv = Uint32Array([1, 2, 3]);
// TypeError: calling a builtin Uint32Array constructor
// without new is forbidden</pre>

<pre class="brush: js example-good notranslate">var dv = new Uint32Array([1, 2, 3]);</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Typed_arrays">JavaScript typed arrays</a></li>
 <li>{{jsxref("ArrayBuffer")}}</li>
 <li>{{jsxref("DataView")}}</li>
</ul>
